# Kenapa Harus Python?

Sebelum kita mulai belajar Python, kita perlu tahu kenapa kita harus belajar Python. Pada materi ini kita akan mulai dengan sejarah awal adanya Python, tren perkembengan Python sampai sekarang, perbandingan dengan bahasa pemrograman yang lain, kelebihan Python yang berguna dalam data science, dan bagaimana perkembangan Python ke depannya.


## Awal Mula Python

Python dikembangkan oleh programmer asal Belanda bernama [Guido van Rossum](https://en.wikipedia.org/wiki/Guido_van_Rossum) di akhir tahun '80-an yang kemudian memublikasikan rilis pertama pada tahun 1991. Python dikembangkan sebagai bahasa pemrograman level tinggi (**high-level**) dan bertujuan umum (**general-purpose**).

Sampai saat ini, versi terakhir Python yang sudah rilis ada versi 3.9.5. Mulai dari tahun 2020, pengembangan dan pemeliharan Python versi 2.x ke bawah (2.7, 2.6, 2.0, 1.8, dan seterusnya) telah dihentikan. Sehingga, sekarang pengguna dan komunitas sangat disarankan menggunakan Python versi 3.x ke atas.

> Python 2.x masih bisa digunakan, hanya saja pengembangan dan pemeliharaannya tidak dilakukan lagi. ([ref](https://www.python.org/dev/peps/pep-0373/))

Di bawah ini visualisasi jadwal rilis beberapa versi Python diambil dari [geeksforgeeks](https://www.geeksforgeeks.org/history-of-python/).

![](https://media.geeksforgeeks.org/wp-content/uploads/20190502023317/TIMELINE.jpg)


## Perbandingan dengan Bahasa Pemrograman Lain

Selain Python, opsi bahasa pemrograman lain yang juga sering digunakan dalam melakukan data science adalah [R](https://www.r-project.org/). Baik R maupun Python merupakan bahasa pemorgraman yang dapat diakses dan digunakan secara gratis oleh siapa saja. Lalu kenapa kita tidak menggunakan R?

Kita perlu membandingkan terlebih dahulu, apa kelebihan dan kekurangan dari masing-masing bahasa, baik R ataupun Python. Mari kita lihat.

### R

* Ditujukan untuk analisis statistik
* Dikembangkan oleh statistikawan untuk statistikawan
* Menyediakan visualisasi yang cantik dan beragam
* Relatif lebih lambat dibandingkan dengan Python
* Tidak bisa digunakan sebagai *back-end* sebuah aplikasi web

### Python

* Mudah untuk dipelajari
* Bisa digunakan untuk berbagai macam tujuan, tidak hanya data science
* Komunitas pengguna yang sangat aktif dan banyak
* Visualisasi di Python lebih kompleks

Karena beberapa poin di atas lah, kita memutuskan untuk menggunakan Python. Kita bisa beralih menggunakan R kalau memang proyek data science yang dikerjakan lebih berat dan seringkali berurusan dengan statistika.


## Tren Penggunaan Python Sekarang dan Masa Depan

Dengan semakin banyaknya yang memakai Python, mulai dari untuk data science, web development, aplikasi permainan, dan lainnya, Python tumbuh dan berkembang menjadi bahasa pemrograman yang sangat populer. Selain itu juga, banyak pengembang yang membuat modul atau pustakanya sendiri untuk bisa dipakai oleh orang lain, sehingga dukungan dari komunitas Python juga besar.

Survei yang dilakukan oleh [stackoverflow pada tahun 2020](https://insights.stackoverflow.com/survey/2020#technology-programming-scripting-and-markup-languages) menempatkan Python pada posisi 4 bahasa pemrograman paling populer, yang sebelumnya pada hasil [survei 2018](https://insights.stackoverflow.com/survey/2018#technology) berada pada posisi 7. Python berhasil mengalahkan (melangkahi) bahasa pemrogrman yang lain seperti SQL, Java, dan Bash/Shell.

GitHub juga memublikasikan [data statistik](https://octoverse.github.com/) semua kode yang ditulis seluruh pengembang/pengguna GitHub. Terlihat tren peringkat Python dari 6 tahun terakhir mengalami kenaikan. Sampai pada tahun 2020 kemarin, Python sudah menduduki peringkat kedua di bawah javascript dan mengambil alih peringkat yang dimiliki oleh Java di tahun sebelumnya.

![python-github](../assets/images/top-languages-gh-2020.png)